{$I QRDEFS.INC}

{
  ----Note for future versions of Delphi----------
  ----Extra components used (not essentials!):----
  ---------JVCL ( www.delphi-jedi.org ) ;---------
  ---------------------Author:--------------------
  ------------Alvaro Ferreira Alves---------------
  -----------alvaro_alves@netcabo.pt--------------
}

unit uMyPreviewRel;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ComCtrls,
  Vcl.ToolWin, Vcl.ExtCtrls, JvExExtCtrls, JvExtComponent, JvSpeedbar,
  JvStringHolder, System.Actions, Vcl.ActnList,
  Vcl.PlatformDefaultStyleActnCtrls, Vcl.ActnMan, Vcl.ImgList, Vcl.AppEvnts,
  QRPrntr, QR5const, QRExtra, printers, QRPDFFilt, QRExport, JvExStdCtrls, JvListBox,
  QRWebFilt, JvEdit, JvGroupBox, Vcl.Grids, JvExGrids, JvGrids, JvExComCtrls,
  JvComCtrls, JvExButtons, JvBitBtn, JvSpacer, JvStatusBar, JvPanel,
  JvExControls, JvButton, JvTransparentButton, JvToolBar,JvComponentBase, JvBalloonHint,
  Vcl.StdStyleActnCtrls;

type
// To have a custom preview be used as the default preview,
// you first define an interface class.  You will provide two
// functions for this class, Show, and ShowModal.
// To make this the standard preview window use this code -
//        RegisterPreviewClass( TQRSimplePreviewInterface );
//        repfrm1.quickrep1.Preview;
// You can change the name TQRSimplePreviewInterface if you like.
//
  TQRSimplePreview = class(TQRPreviewInterface)
  public
    function Show(AQRPrinter : TQRPrinter) : TWinControl; override;
    function ShowModal(AQRPrinter : TQRPrinter): TWinControl; override;
  end;

  TMyPreviewRel = class(TForm)
    JvStatusBar1: TJvStatusBar;
    QRPreview: TQRPreview;
    ApplicationEvents1: TApplicationEvents;
    ImgListEnabled: TImageList;
    JvStrHolder: TJvStrHolder;
    imgListDisabled: TImageList;
    ActionManager1: TActionManager;
    ActionLoadReport: TAction;
    ActionSaveQRP: TAction;
    ActionSavePDF: TAction;
    ActionSaveHTML: TAction;
    ActionSaveCSV: TAction;
    ActionPrint: TAction;
    ActionFirstPage: TAction;
    ActionPriorPage: TAction;
    ActionNextPage: TAction;
    ActionLastPage: TAction;
    ActionGotoPage: TAction;
    ActionZoomToFit: TAction;
    ActionZoomTo100: TAction;
    ActionZoomToWidth: TAction;
    ActionMoreZoom: TAction;
    ActionLessZoom: TAction;
    ActionExit: TAction;
    ActionSearchText: TAction;
    Tabs: TPageControl;
    TabThumbs: TTabSheet;
    ThumbGrid: TDrawGrid;
    TabSearchResult: TTabSheet;
    GroupBox1: TGroupBox;
    SearchResultBox: TListBox;
    edSearch: TEdit;
    ActionSaveXLS: TAction;
    Splitter1: TSplitter;
    JvToolBar: TJvToolBar;
    tbLoadReport: TToolButton;
    tbSeparator1: TToolButton;
    tbSaveQRP: TToolButton;
    tbSeparator2: TToolButton;
    tbSeparator3: TToolButton;
    tbSavePDF: TToolButton;
    tbSeparator4: TToolButton;
    tbSaveXLS: TToolButton;
    tbSeparator5: TToolButton;
    tbSaveHTML: TToolButton;
    tbSeparator6: TToolButton;
    tbSaveCSV: TToolButton;
    JvToolBarSearch: TJvToolBar;
    tbSearchText: TToolButton;
    tbSeparator7: TToolButton;
    tbPrint: TToolButton;
    tbSeparator8: TToolButton;
    tbFirstPage: TToolButton;
    tbPriorPage: TToolButton;
    tbNextPage: TToolButton;
    tbLastPage: TToolButton;
    tbSeparator9: TToolButton;
    TabLanguage: TTabSheet;
    RadioGroup1: TRadioGroup;
    tbGotoPage: TToolButton;
    tbSeparator10: TToolButton;
    tbZoomToFit: TToolButton;
    tbSeparator11: TToolButton;
    tbZoomToWidth: TToolButton;
    tbZoomTo100: TToolButton;
    tbSeparator12: TToolButton;
    tbSeparator13: TToolButton;
    tbMoreZoom: TToolButton;
    tbLessZoom: TToolButton;
    tbSeparator14: TToolButton;
    tbSeparator15: TToolButton;
    tbExit: TToolButton;
    ActionChangeLanguage: TAction;
    ListBox1: TListBox;
    tbSeparator16: TToolButton;
    JvBalloonHint1: TJvBalloonHint;
    Splitter2: TSplitter;
    pnlPage: TPanel;
    ToolButton1: TToolButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure ActionLoadReportExecute(Sender: TObject);
    procedure ActionSaveQRPExecute(Sender: TObject);
    procedure ActionSavePDFExecute(Sender: TObject);
    procedure ActionSaveHTMLExecute(Sender: TObject);
    procedure ActionSaveCSVExecute(Sender: TObject);
    procedure ActionPrintExecute(Sender: TObject);
    procedure ActionFirstPageExecute(Sender: TObject);
    procedure ActionFirstPageUpdate(Sender: TObject);
    procedure ActionPriorPageExecute(Sender: TObject);
    procedure ActionPriorPageUpdate(Sender: TObject);
    procedure ActionNextPageExecute(Sender: TObject);
    procedure ActionNextPageUpdate(Sender: TObject);
    procedure ActionLastPageExecute(Sender: TObject);
    procedure ActionLastPageUpdate(Sender: TObject);
    procedure ActionGotoPageExecute(Sender: TObject);
    procedure ActionGotoPageUpdate(Sender: TObject);
    procedure ActionZoomToFitExecute(Sender: TObject);
    procedure ActionZoomTo100Execute(Sender: TObject);
    procedure ActionZoomToWidthExecute(Sender: TObject);
    procedure ActionMoreZoomExecute(Sender: TObject);
    procedure ActionLessZoomExecute(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
    procedure SearchResultBoxClick(Sender: TObject);
    procedure QRPreviewHyperlink(Sender: TObject;
      EventType: TQRHyperlinkEventType; Link: string; var Handled: Boolean);
    procedure QRPreviewMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure QRPreviewPageAvailable(Sender: TObject; PageNum: Integer);
    procedure QRPreviewProgressUpdate(Sender: TObject; Progress: Integer);
    procedure ActionSearchTextExecute(Sender: TObject);
    procedure ActionSaveXLSExecute(Sender: TObject);
    procedure ThumbGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      ARect: TRect; State: TGridDrawState);
    procedure ThumbGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure RadioGroup1Click(Sender: TObject);
    procedure ActionChangeLanguageExecute(Sender: TObject);
    procedure ActionChangeLanguageUpdate(Sender: TObject);
    procedure ActionSearchTextUpdate(Sender: TObject);
  protected
    procedure WndProc( var Message : TMessage ); override;
  private
    { Private declarations }
    FQRPrinter : TQRPrinter;
    FReportOrientation : TPrinterOrientation;
    Gauge : TProgressBar;
    LastProgress : integer;
    ThumbFontHeight,
    ThumbDrawHeight,
    ThumbDrawWidth,
    ThumbTopMargin,
    ThumbLeftMargin : integer;
    ShowThumbs, ShowSearch : boolean;
    InitZoom : TQRZoomstate;
  public
    { Public declarations }
    constructor CreatePreview(AOwner : TComponent; aQRPrinter : TQRPrinter); virtual;
    procedure Show;
    procedure UpdateInfo;
    procedure SelectPage(aPageNumber : integer);
    procedure ResizeThumb(Sender : TObject);
    property QRPrinter : TQRPrinter read FQRPrinter write FQRPrinter;
  end;

  TResizeGrid = class(TDrawGrid)
  public
    property OnResize;
  end;

const
  //Messages
  MsgPage = 0;//Pgina
  MsgOf = 1;//de
  MsgFileQRP = 2;//Ficheiros QuickRep (*.QRP)|*.QRP
  MsgFilePDF = 3;//Ficheiros Adobe PDF(*.pdf)|*.PDF
  MsgFileExcel = 4;//Ficheiros Microsoft Excel(*.xls)|*.XLS
  MsgFileHTML = 5;//Ficheiros HTML(*.html)|*.HTML
  MsgFileTXT = 6;//Ficheiros TXT(*.txt)|*.TXT
  MsgAttention = 7;//Ateno
  MsgSelectPage = 8;//Seleco da pgina: de 1 at
  MsgEnterNumber = 9;//Digite o nmero da pgina:
  MsgCancel = 10;//Cancelar
  MsgSave = 11;//Guardar como
  MsgNoResult = 12;//Sem resultados
  MsgNoFile = 13;//O ficheiro no existe
  MsgNoLanguage = 14;//O idioma ainda no est disponvel.

var
  MyPreviewRel: TMyPreviewRel;

implementation

uses qrsearchdlg,
     quickrpt,
     Clipbrd,
     ResourceLocalizer;

var
  ThumbUpdating,ThumbSelecting : boolean;
  ReportTitle                  : string;
  FParentReport                : TCustomQuickrep;
  eventHandled                 : boolean;

{$R *.dfm}
{$R .\resources\Mycursor.res}
{$R .\resources\PreviewCaptions.res}

function TQRSimplePreview.Show(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := TMyPreviewRel.CreatePreview(Application, AQRPrinter);
  TMyPreviewRel(Result).Show;
end;

function TQRSimplePreview.ShowModal(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := TMyPreviewRel.CreatePreview(Application, AQRPrinter);
  TMyPreviewRel(Result).ShowModal;
end;

function IsNumeric(const S: String): Boolean;
//funo que determina se um valor  numrico
var
	x: SmallInt;
begin
	Result:= True;
	for x:= 1 to Length(S) do
	  begin
	  	if not(S[x] in['0'..'9']) then
		    begin
			    Result:= False;
          Break;
		    end;
	  end;
end;

procedure TMyPreviewRel.WndProc( var Message : TMessage );
var
  i : smallint;
begin
  if Message.Msg = WM_MOUSEWHEEL then
   begin
     Message.Msg := WM_KEYDOWN;
     Message.lParam := 0;
     try
       i := Message.wParam div $1000;
       if i > 0 then
         Message.wParam := VK_UP
       else
         Message.wParam := VK_DOWN;
     except
         Message.wParam := VK_DOWN;
     end;
   end;
  inherited WndProc( message );
end;

procedure Sleep100(SleepZ : Integer);
var
  StartValue : LongInt;
begin
  StartValue := GetTickCount;
  while ((GetTickCount - StartValue) <= (SleepZ * 10)) do
    Application.ProcessMessages;
end;

procedure TMyPreviewRel.ActionChangeLanguageExecute(Sender: TObject);
var
  i : integer;
begin
  Screen.Cursor := crHourGlass;
  MyPreviewRel.Caption := ListBox1.Items[17];//Pr-visualizar o relatrio
  for i := JvStrHolder.Strings.Count -1 downto 0 do
    JvStrHolder.Strings.Delete(i);
  GroupBox1.Caption := ListBox1.Items[0];//Digite o texto:
  JvStatusBar1.Panels[2].Text := ListBox1.Items[1];//Pgina
  for i := 2 to 16 do
    JvStrHolder.Strings.Add(ListBox1.Items[i]);
  TabLanguage.Caption := ListBox1.Items[18];//Idioma
  TabSearchResult.Caption := ListBox1.Items[19];//Procurar texto
  TabThumbs.Caption := ListBox1.Items[20];//Miniaturas
  tbExit.Hint := ListBox1.Items[21];//fechar|fechar a janela
  tbFirstPage.Hint := ListBox1.Items[22];//primeira pgina|ir para a primeira pgina
  tbGotoPage.Hint := ListBox1.Items[23];//ir para...|ir para outra pgina
  tbLastPage.Hint := ListBox1.Items[24];//ltima pgina|ir para a ltima pgina
  tbLessZoom.Hint := ListBox1.Items[25];//zoom (-)|diminuir o zoom da pgina
  tbLoadReport.Hint := ListBox1.Items[26];//abrir (QRP)|abrir um relatrio no formato quick report (QRP)
  tbMoreZoom.Hint := ListBox1.Items[27];//zoom (+)|aumentar o zoom da pgina
  tbNextPage.Hint := ListBox1.Items[28];//pgina seguinte|ir para a pgina seguinte
  tbPrint.Hint := ListBox1.Items[29];//imprimir|imprimir o relatrio
  tbPriorPage.Hint := ListBox1.Items[30];//pgina anterior|ir para a pgina anterior
  tbSaveCSV.Hint := ListBox1.Items[31];//guardar (TXT)|guardar no formato TXT
  tbSaveHTML.Hint := ListBox1.Items[32];//guardar (HTML)|guardar no formato HTML
  tbSavePDF.Hint := ListBox1.Items[33];//guardar (PDF)|guardar no formato acrobat reader
  tbSaveQRP.Hint := ListBox1.Items[34];//guardar (QRP)|guardar no formato quick report
  tbSaveXLS.Hint := ListBox1.Items[35];//guardar (XLS)|guardar no formato Excel
  tbSearchText.Hint := ListBox1.Items[36];//procurar texto|procurar um texto no relatrio
  tbZoomTo100.Hint := ListBox1.Items[37];//100%|zoom a 100%
  tbZoomToFit.Hint := ListBox1.Items[38];//altura|mostrar pgina inteira
  tbZoomToWidth.Hint := ListBox1.Items[39];//largura|mostrar a pgina  largura

  Invalidate;
  Sleep100(200);
  Screen.Cursor := crDefault;
end;

procedure TMyPreviewRel.ActionChangeLanguageUpdate(Sender: TObject);
begin
  ActionChangeLanguage.Enabled := RadioGroup1.ItemIndex <> -1;
end;

procedure TMyPreviewRel.ActionExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMyPreviewRel.ActionFirstPageExecute(Sender: TObject);
begin
  //primeira pgina
  SelectPage(1);
end;

procedure TMyPreviewRel.ActionFirstPageUpdate(Sender: TObject);
begin
  ActionFirstPage.Enabled := QRPreview.PageNumber > 1;
end;

procedure TMyPreviewRel.ActionLastPageExecute(Sender: TObject);
begin
  //ltima pgina
  if (qrprinter.status = mpFinished) then
    SelectPage(QRPrinter.PageCount)
  else
    SelectPage(QRPrinter.PageCount - 1);
end;

procedure TMyPreviewRel.ActionLastPageUpdate(Sender: TObject);
begin
  ActionLastPage.Enabled := QRPreview.PageNumber < qrPreview.qrPrinter.PageCount;
end;

procedure TMyPreviewRel.ActionLessZoomExecute(Sender: TObject);
begin
  //diminuir o zoom
  Application.ProcessMessages;
  if QRPreview.Zoom >= 47 then
    begin
      QRPreview.Zoom := QRPreview.Zoom - 20;
      JvStatusBar1.Panels[0].Text := IntToStr(QRPreview.Zoom) + '%';
    end
  else
    ActionZoomToFitExecute(self);
end;

procedure TMyPreviewRel.ActionLoadReportExecute(Sender: TObject);
begin
  eventHandled := false;
  if assigned(FParentReport.OnStandPrevEvent) then
              FParentReport.OnStandPrevEvent( self, spLoad, 'Load',eventHandled);
  if eventHandled then exit;

  with TOpenDialog.Create(Application) do
  try
    Title := SqrLoadReport;
    Filter := SqrQRFile + ' (*.' +cQRPDefaultExt + ')|*.' + cqrpDefaultExt;
    if Execute then
      if FileExists(FileName) then
      begin
        QRPrinter.Load(Filename);
        reportTitle := filename;
        QRPreview.PageNumber := 1;
        QRPreview.PreviewImage.PageNumber := 1;
        // fix orientation bug. NOTE : this sould be done in qrprinter.load()
        FReportOrientation := QRPrinter.Orientation;
        qrprinter.aPrinterSettings.Orientation := QRPrinter.Orientation;
        TQuickrep(qrprinter.ParentReport).Page.PaperSize := qrprinter.aPrinterSettings.PaperSize;
        TQuickrep(qrprinter.ParentReport).Page.Orientation := QRPrinter.Orientation;
        qrpreview.UpdateZoom; // fixes thumb orientation
        // have to reset the thumbs with this call
        resizeThumb( self);
        QRPreviewPageAvailable( self, 1);
        ThumbGrid.Row := 0;
        PrintMetafileFromPreview := true;
        ActionPrint.Enabled := true;
      end
      else
        ShowMessage(JvStrHolder.Strings[MsgNoFile]);
  finally
    free;
  end;
end;

procedure TMyPreviewRel.ActionMoreZoomExecute(Sender: TObject);
begin
  //aumentar o zoom
  Application.ProcessMessages;
  if QRPreview.Zoom <= 200 then
    begin
      QRPreview.Zoom := QRPreview.Zoom + 20;
      JvStatusBar1.Panels[0].Text := IntToStr(QRPreview.Zoom) + '%';
    end
  else
    //ActionZoomToFitExecute(self);
    Exit;
end;

procedure TMyPreviewRel.ActionNextPageExecute(Sender: TObject);
begin
  //pgina seguinte
  SelectPage(QRPreview.PageNumber + 1);
end;

procedure TMyPreviewRel.ActionNextPageUpdate(Sender: TObject);
begin
  ActionNextPage.Enabled := QRPreview.PageNumber < qrPreview.qrPrinter.PageCount;
end;

procedure TMyPreviewRel.ActionPrintExecute(Sender: TObject);
var
  printDialog        : TPrintDialog;
  startPage, endPage : Integer;
begin
  // Create a printer selection dialog
  printDialog := TPrintDialog.Create(MyPreviewRel);
  // Set up print dialog options
  printDialog.MinPage := 1;// First allowed page number
  printDialog.MaxPage := QRPrinter.PageCount;// Highest allowed page number
  printDialog.ToPage  := QRPrinter.PageCount;// 1 to ToPage page range allowed
  printDialog.Options := [poPageNums];// Allow page range selection
  // If the user has selected a printer (or default), then print!
  if printDialog.Execute then
   begin
     // Use the Printer function to get access to the global TPrinter object.
     // Set to landscape orientation
     Printer.Orientation := poLandscape;
     // Has the user selected a page range?
     if printDialog.PrintRange = prPageNums then
       begin
         startPage := printDialog.FromPage;
         endPage   := printDialog.ToPage;
       end
     else // All pages
       begin
         startPage := 1;
         endPage   := QRPrinter.PageCount;
       end;
     QRPrinter.FirstPage := startpage;
     QRPrinter.LastPage := endpage;
     QRPrinter.Copies := PrintDialog.Copies;
     QRPrinter.Print;
   end;
end;

procedure TMyPreviewRel.ActionPriorPageExecute(Sender: TObject);
begin
  //pgina anterior
  SelectPage(QRPreview.PageNumber - 1);
end;

procedure TMyPreviewRel.ActionPriorPageUpdate(Sender: TObject);
begin
  ActionPriorPage.Enabled := QRPreview.PageNumber > 1;
end;

procedure TMyPreviewRel.ActionSaveCSVExecute(Sender: TObject);
var
  CSVFilter : TQRCommaSeparatedFilter;
  FileExt   : string;
begin
  //guardar no formato TXT
  CSVFilter := nil;
  with TSaveDialog.Create(Application) do
  try
    Filter := JvStrHolder.Strings[MsgFileTXT];
    //Filter := 'Ficheiros TXT(*.txt)|*.TXT';
    Title := JvStrHolder.Strings[MsgSave];
    //Title := 'Guardar como';
    FileName := QRPreview.QRPrinter.Title;
    if Execute then
      begin
       if pos('.',FileName) > 0 then
         FileName := Copy(FileName, 1, pos('.',FileName)-1)+'.txt'
       else FileName := FileName+'.txt';
       FileExt := FileName;
       CSVFilter := TQRCommaSeparatedFilter.Create(FileExt);
       QRPreview.QRPrinter.ExportToFilter(CSVFilter);
       CSVFilter.Free;
      end;//if
  finally
    Free;
  end;//try
end;

procedure TMyPreviewRel.ActionSaveHTMLExecute(Sender: TObject);
var
  HTMLFilter : TQRGHTMLDocumentFilter;
  FileExt    : string;
begin
  //guardar no formato HTML
  HTMLFilter := nil;
  with TSaveDialog.Create(Application) do
  try
    Filter := JvStrHolder.Strings[MsgFileHTML];
    //Filter := 'Ficheiros HTML(*.html)|*.HTML';
    Title := JvStrHolder.Strings[MsgSave];
    //Title := 'Guardar como';
    FileName := QRPreview.QRPrinter.Title;
    if Execute then
      begin
       if pos('.',FileName) > 0 then
         FileName := Copy(FileName, 1, pos('.',FileName)-1)+'.html'
       else FileName := FileName+'.html';
       FileExt := FileName;
       HTMLFilter := TQRGHTMLDocumentFilter.Create(FileExt);
       HTMLFilter.Concat := true;
       QRPreview.QRPrinter.ExportToFilter(HTMLFilter);
       HTMLFilter.EndConcat;
       HTMLFilter.Free;
      end;//if
  finally
    Free;
  end;//try
end;

procedure TMyPreviewRel.ActionSavePDFExecute(Sender: TObject);
var
  PDFFilt : TQRPDFDocumentFilter;
  FileExt : string;
begin
  //guardar no formato acrobat reader - PDF
  PDFFilt := nil;
  with TSaveDialog.Create(Application) do
  try
    Filter := JvStrHolder.Strings[MsgFilePDF];
    //Filter := 'Ficheiros Adobe PDF(*.pdf)|*.PDF';
    Title := JvStrHolder.Strings[MsgSave];
    //Title := 'Guardar como';
    FileName := QRPreview.QRPrinter.Title;
    if Execute then
      begin
       if pos('.',FileName) > 0 then
         FileName := Copy(FileName, 1, pos('.',FileName)-1)+'.pdf'
       else FileName := FileName+'.pdf';
       FileExt := FileName;
       PDFFilt := TQRPDFDocumentFilter.Create(FileExt);
       PDFFilt.AddFontMap('WebDings:ZapfDingBats');
       PDFFilt.TextOnTop := true;
       PDFFilt.LeftMargin := 0;
       PDFFilt.topMargin := 0;
       PDFFilt.CompressionOn := false;
       PDFFilt.Concatenating := true;
       QRPreview.QRPrinter.ExportToFilter(PDFFilt);
       PDFFilt.EndConcat;
       PDFFilt.Free;
      end;//if
  finally
    Free;
  end;//try
end;

procedure TMyPreviewRel.ActionSaveQRPExecute(Sender: TObject);
var
  QRPFilter : TQRExportFilter;
  FileExt   : string;
begin
  //guardar no formato QuickReport - qrp
  QRPFilter := nil;
  with TSaveDialog.Create(Application) do
   try
    Filter := JvStrHolder.Strings[MsgFileQRP];
    //Filter := 'Ficheiros QuickReport(*.qrp)|*.QRP';
    Title := JvStrHolder.Strings[MsgSave];
    //Title := 'Guardar como';
    FileName := QRPreview.QRPrinter.Title;
    if Execute then
      begin
       if pos('.',FileName) > 0 then
         FileName := Copy(FileName, 1, pos('.',FileName)-1)+'.qrp'
       else FileName := FileName+'.qrp';
       FileExt := FileName;
       QRPFilter := TQRExportFilter.Create(FileExt);
       QRPrinter.Save(FileExt);
       QRPFilter.Free;
      end;//if
   finally
    Free;
   end;//try
end;

procedure TMyPreviewRel.ActionSaveXLSExecute(Sender: TObject);
var
  XLSFilter : TQRxlsFilter;
  FileExt   : string;
begin
  //guardar no formato Microsoft Excel - xls
  XLSFilter := nil;
  with TSaveDialog.Create(Application) do
  try
    Filter := JvStrHolder.Strings[MsgFileExcel];
    //Filter := 'Ficheiros Microsoft Excel(*.xls)|*.XLS';
    Title := JvStrHolder.Strings[MsgSave];
    //Title := 'Guardar como';
    FileName := QRPreview.QRPrinter.Title;
    if Execute then
      begin
       if pos('.',FileName) > 0 then
         FileName := Copy(FileName, 1, pos('.',FileName)-1)+'.xls'
       else FileName := FileName+'.xls';
       FileExt := FileName;
       XLSFilter := TQRxlsFilter.Create(FileExt);
       XLSFilter.Concatenating := true;
       QRPreview.QRPrinter.ExportToFilter(XLSFilter);
       XLSFilter.EndConcat;
       XLSFilter.Free;
      end;//if
  finally
    Free;
  end;//try
end;

procedure TMyPreviewRel.ActionGotoPageExecute(Sender: TObject);
var
  Pnum  : integer;
  sKey  : string;
begin
  Pnum := 0;
  sKey := IntToStr(QRPreview.PageNumber);
  InputQuery(JvStrHolder.Strings[MsgSelectPage] + ' ' +
             IntToStr(QRPreview.QRPrinter.PageCount),
             JvStrHolder.Strings[MsgEnterNumber], sKey);
  if not(IsNumeric(sKey)) then
    Exit
  else
    begin
      Pnum := StrToInt(sKey);
      if (Pnum < 1) or (Pnum > QRPrinter.PageCount) then
        Pnum := 1;
    end;
  SelectPage(Pnum);
end;

procedure TMyPreviewRel.ActionGotoPageUpdate(Sender: TObject);
begin
  ActionGotoPage.Enabled := QRPreview.qrPrinter.PageCount > 1;
end;

procedure TMyPreviewRel.ActionSearchTextExecute(Sender: TObject);
var
  FindStr   : string;
  MatchCase : boolean;
  I         : integer;
  APage     : TMetafile;
begin
  //procurar texto
  if qrprinter.Status = mpBusy then exit;
  if edSearch.Text <> '' then
   begin
     //SearchResultBox.Enabled := true;
     FindStr := edSearch.Text;
     SearchResultBox.Items.Clear;
   for I := 1 to QRPrinter.PageCount do
     begin
       APage := QRPrinter.GetPage(I);
       try
         if StrInMetafile(FindStr, APage, MatchCase) then
            SearchResultBox.Items.AddObject(JvStrHolder.Strings[MsgPage]+' ' +
            IntToStr(I),TObject(I));
       finally
         APage.Free;
       end;
     end;
    if SearchResultBox.Items.Count = 0 then
    begin
      SearchResultBox.Items.Add(JvStrHolder.Strings[MsgNoResult]);
      SearchResultBox.Enabled := false;
    end;
   end;
end;

procedure TMyPreviewRel.ActionSearchTextUpdate(Sender: TObject);
begin
  ActionSearchText.Enabled := edSearch.Text <> '';
end;

procedure TMyPreviewRel.ActionZoomTo100Execute(Sender: TObject);
begin
  Application.ProcessMessages;
  QRPreview.Zoom := 100;
  QRPreview.UpdateZoom;
  JvStatusBar1.Panels[0].Text := IntToStr(QRPreview.Zoom) + '%';
  tbZoomTo100.Down := true;
end;

procedure TMyPreviewRel.ActionZoomToFitExecute(Sender: TObject);
begin
  Application.ProcessMessages;
  QRPreview.ZoomToFit;
  JvStatusBar1.Panels[0].Text := IntToStr(QRPreview.Zoom) + '%';
end;

procedure TMyPreviewRel.ActionZoomToWidthExecute(Sender: TObject);
begin
  Application.ProcessMessages;
  QRPreview.ZoomToWidth;
  JvStatusBar1.Panels[0].Text := IntToStr(QRPreview.Zoom) + '%';
end;

procedure TMyPreviewRel.ApplicationEvents1Hint(Sender: TObject);
begin
  //mostrar o hint dos botes na SatusBar
  JvStatusBar1.Panels[1].Text := Application.Hint;
end;

constructor TMyPreviewRel.CreatePreview(AOwner : TComponent; aQRPrinter : TQRPrinter);
var
  localZoom : integer;//ZOOM FIX
begin
  inherited Create(AOwner);
  self.Icon := Application.Icon;
  // set captions
  {
  Tabs.Pages[0].Caption := JvStrHolder.Strings[MsgThumbs];//Miniaturas
  Tabs.Pages[1].Caption := JvStrHolder.Strings[MsgSearchResult];//Resultado da procura
  GroupBox1.Caption := JvStrHolder.Strings[MsgSearchText];//Procurar texto
  }
  Tabs.ActivePage := TabThumbs;
  QRPrinter := aQRPrinter;
  // qr5 Tiburon this line moved up from below because of resize failure.
  QRPreview.QRPrinter := aQRPrinter;
  if qrprinter.parentreport is TCustomquickrep then
   begin
     FParentReport := TCustomquickrep(qrprinter.ParentReport);
     ShowThumbs := TCustomquickrep(qrprinter.ParentReport).PrevShowThumbs;
     ShowSearch := TCustomquickrep(qrprinter.ParentReport).PrevShowSearch;
     InitZoom := TCustomquickrep(qrprinter.ParentReport).PrevInitialZoom;
     localZoom := TCustomquickrep(qrprinter.ParentReport).zoom; // ZOOM FIX
     FReportOrientation := TCustomquickrep(qrprinter.ParentReport).Page.Orientation;
     eventHandled := false;
     if assigned(FParentReport.OnStandPrevEvent) then
                 FParentReport.OnStandPrevEvent( self, spOpen, '',eventHandled);
   end
  else
   begin // this should never happen
     WindowState := wsMaximized;
     ShowThumbs := true;
     ShowSearch := true;
     localZoom := 100; // ZOOM FIX
     FParentReport := nil;
  end;
  QRPreview.QRPrinter.Orientation := FReportOrientation;
  if (QRPrinter <> nil) and (QRPrinter.Title <> '') then Caption := sqrPreviewWindowCaption + QRPrinter.Title;
  Gauge := TProgressBar.Create(Self);
  Gauge.Top := 2;
  Gauge.Left := 2;
  Gauge.Height := 10;
  Gauge.Width := 100;
  LastProgress := 0;
  // qrprinter.load -> qrprinter.preview grid bug fix
  ThumbGrid.RowCount := 1; // ******************
  Tabs.Visible := ShowThumbs or ShowSearch;
  try
    if Tabs.Visible and (QRPrinter.PageCount > 0) then
      ThumbGrid.RowCount := QRPrinter.PageCount;

    if Tabs.Visible then
      TabThumbs.TabVisible := ShowThumbs;
    tbSearchText.Visible := ShowSearch;
    if not ShowSearch and Tabs.Visible then
     begin
       TabSearchResult.TabVisible := false;
       tbSearchText.Visible := false;
     end;
  except
    //
  end;
  if InitZoom = QRZoomToFit then
   begin
     QRPreview.ZoomToFit ;
     //tbZoomToFit.Down := true;
   end
  else if InitZoom = QRZoomToWidth then
   begin
     QRPreview.ZoomToWidth;
     //tbZoomToWidth.Down := true;
   end
  else
   begin
     QRPreview.Zoom := localZoom;// ZOOM FIX
     QRPreview.UpdateZoom;
     //tbZoomTo100.Down := true;
   end;
  if qrprinter.status = mpFinished then
    ActionPrint.Enabled := true;
end;

procedure TMyPreviewRel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if qrprinter.Status = mpBusy then
   begin
     Action := caNone;
     exit;
   end;
  eventHandled := false;
  if assigned(FParentReport.OnStandPrevEvent) then
              FParentReport.OnStandPrevEvent( self, spclose, '',eventHandled);
  QRPrinter.ClosePreview(Self);
  application.ProcessMessages;
  Action := caFree;
end;

procedure TMyPreviewRel.FormCreate(Sender: TObject);
const
  MyCursor = 1;
begin
  Screen.Cursors[MyCursor] := LoadCursor(HInstance,'Mycursor');
  HorzScrollbar.Tracking := true;
  VertScrollbar.Tracking := true;
  TResizeGrid(ThumbGrid).OnResize := ResizeThumb;
  JvStatusBar1.Panels[0].Text := IntToStr(QRPreview.Zoom) + '%';

  TResourceLocalizer.GetLanguages(RadioGroup1.Items);
end;

procedure TMyPreviewRel.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  prevpage : integer;
begin
 try
  case Key of
    VK_Next : if Shift = [ssCtrl] then
                ActionLastPageExecute(Self)
              else
                ActionNextPageExecute(Self);
    VK_Prior : if Shift = [ssCtrl] then
                 ActionFirstPageExecute(Self)
               else
                 ActionPriorPageExecute(Self);
    VK_Home : ActionFirstPageExecute(Self);
    VK_End : ActionLastPageExecute(Self);
    VK_Escape : ActionExitExecute(self);
    VK_Down :
    begin
      if ((QRPreview.VertScrollBar.Position + QRPreview.VertScrollBar.Increment)<(QRPreview.VertScrollBar.Range - QRPreview.Height)) then
        QRPreview.VertScrollBar.Position := QRPreview.VertScrollBar.Position + QRPreview.VertScrollBar.Increment
      else
      begin
        ThumbSelecting := true;
        ActionNextPageExecute(Self);
        ThumbSelecting := false;
      end;
    end;
    VK_Up :
    begin
      if (QRPreview.VertScrollBar.Position-QRPreview.VertScrollBar.Increment)>0 then
      begin
        QRPreview.VertScrollBar.Position := QRPreview.VertScrollBar.Position - QRPreview.VertScrollBar.Increment;
      end
      else
      begin
        ThumbSelecting := true;
        prevpage := QRPreview.PageNumber;
        ActionPriorPageExecute(Self);
        ThumbSelecting := false;
        if prevpage > 1 then
           QRPreview.VertScrollBar.Position := (QRPreview.VertScrollBar.Range - QRPreview.Height) - QRPreview.VertScrollBar.Increment
        else
           QRPreview.VertScrollBar.Position := 0;
      end;
    end;
  end;
 except
     // something wrong with mouse wheel ?
 end;
end;

procedure TMyPreviewRel.FormResize(Sender: TObject);
begin
  QRPreview.UpdateZoom;
end;

procedure TMyPreviewRel.QRPreviewHyperlink(Sender: TObject;
  EventType: TQRHyperlinkEventType; Link: string; var Handled: Boolean);
begin
  JvStatusbar1.Panels[3].Text := Link;
end;

procedure TMyPreviewRel.QRPreviewMouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
  kd : word;
begin
  kd := vk_down;
  formkeydown(self, kd, []);
  handled := true;
end;

procedure TMyPreviewRel.QRPreviewPageAvailable(Sender: TObject;
  PageNum: Integer);
begin
  UpdateInfo;
  ThumbGrid.RowCount := QRPrinter.PageCount;
  ThumbGrid.Invalidate;
  if qrprinter.status = mpFinished then
    begin
      ActionPrint.Enabled := true;
      ActionSaveQRP.Enabled := true;
      ActionLoadReport.Enabled := true;
      ActionSearchText.Enabled := true;
      ActionGotoPage.Enabled := true;
      ActionFirstPage.Enabled := true;
      ActionNextPage.Enabled := true;
      ActionPriorPage.Enabled := true;
      ActionLastPage.Enabled := true;
      ThumbGrid.RowCount := QRPrinter.PageCount;
      Sleep(100);
    end
  else
    begin
      ThumbGrid.RowCount := QRPrinter.PageCount-1;
      ActionPrint.Enabled := false;
      ActionSaveQRP.Enabled := false;
      ActionLoadReport.Enabled := false;
      ActionSearchText.Enabled := false;
      ActionGotoPage.Enabled := false;
      ActionFirstPage.Enabled := false;
      ActionNextPage.Enabled := false;
      ActionPriorpage.Enabled := false;
      ActionLastPage.Enabled := false;
    end;

  // QR5  stop report after n pages
  if (QRPrinter.PageCount = FParentReport.PagesInPreview) and (FParentReport.PagesInPreview<>0) then
      FParentReport.UserCancel := true;
end;

procedure TMyPreviewRel.QRPreviewProgressUpdate(Sender: TObject;
  Progress: Integer);
begin
  if Progress >= LastProgress + 5 then
    begin
      JvStatusBar1.Panels[0].Text := IntToStr(Progress)+'%';
      LastProgress := Progress;
    end;
  if (Progress = 0) or (Progress = 100) then JvStatusBar1.Panels[0].Text := '';
end;

procedure TMyPreviewRel.Show;
begin
  inherited Show;
  UpdateInfo;
end;

procedure TMyPreviewRel.ThumbGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  ARect: TRect; State: TGridDrawState);
var
  APage : TMetafile;
begin
  APage := QRPrinter.GetPage(ARow+1);
  if APage <> nil then
    PaintPageToCanvas(APage, ThumbGrid.Canvas, Rect(ARect.Left + ThumbLeftMargin, ARect.Top + 10,
                      ARect.Right - 30, ARect.Bottom - 10), true);
  ThumbGrid.Canvas.Brush.Color := clBtnFace;
  ThumbGrid.Canvas.pen.Color := clblack;
  SetBkMode(ThumbGrid.Canvas.Handle, TRANSPARENT);
  ThumbGrid.Canvas.Textout(ARect.Left, ARect.Top, IntToStr(ARow + 1));
  SetBkMode(ThumbGrid.Canvas.Handle, OPAQUE);
  APage.Free;
end;

procedure TMyPreviewRel.ThumbGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  if ThumbUpdating or ThumbSelecting then exit;
  ThumbSelecting := true;
  if QRPreview.PageNumber <> (ARow + 1) then
    QRPreview.PageNumber := ARow + 1;
  UpdateInfo;
  Thumbselecting := false;
end;

procedure TMyPreviewRel.UpdateInfo;
begin
  try
    pnlPage.Caption := JvStrHolder.Strings[MsgPage] + ' ' +
              Inttostr(QRPreview.PageNumber)+ ' ' +
              JvStrHolder.Strings[MsgOf] + ' ' +
              IntToStr(QRPreview.qrPrinter.PageCount);
    JvStatusBar1.Panels[2].Text := JvStrHolder.Strings[MsgPage] + ' ' +
                 IntToStr(QRPreview.PageNumber) + ' ' +
                 JvStrHolder.Strings[MsgOf] + ' ' +
                 IntToStr(QRPreview.QRPrinter.PageCount);
  except
  end;
  JvStatusBar1.Panels[3].Text := ReportTitle;
end;

procedure TMyPreviewRel.SearchResultBoxClick(Sender: TObject);
var
  Page : integer;
begin
  with SearchResultBox do
    if ItemIndex >= 0 then
      Page := Integer(Items.Objects[ItemIndex])
    else
      Page := 1;
  if (Page < 1) or (Page > QRPrinter.PageCount) then
    Page := 1;
  SelectPage(Page);
end;

procedure TMyPreviewRel.SelectPage(aPageNumber : integer);
begin
  try
   QRPreview.PageNumber := APageNumber;
   UpdateInfo;
   // set thumb row
   if ((aPagenumber > 0) and ( aPagenumber <= QRPrinter.PageCount) and (aPagenumber <= ThumbGrid.RowCount)) then
    begin
      ThumbUpdating := true;
      ThumbGrid.Row := APageNumber-1;
      ThumbUpdating := false;
    end;
  except
  end;
end;

procedure TMyPreviewRel.RadioGroup1Click(Sender: TObject);
var
  LanguageIndex     : integer;
  LanguageResOffset : integer;
begin
  try
    //locate selected item (exit if not assigned)
    LanguageIndex := RadioGroup1.ItemIndex;
    if LanguageIndex = -1 then
      Exit;

    //get language ofsset
    LanguageResOffset := Integer(RadioGroup1.Items.Objects[LanguageIndex]);

    TResourceLocalizer.GetStrings(ListBox1.Items,LanguageResOffset,[1,2,3,4,5,6,7,
       8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,
       34,35,36,37,38,39,40]);

    ActionChangeLanguageExecute(Self);
  except
    on E:EStringListError do
      raise Exception.Create(JvStrHolder.Strings[MsgNoLanguage]);
  end;
end;

procedure TMyPreviewRel.ResizeThumb(Sender: TObject);
begin
  ThumbFontHeight := ThumbGrid.Canvas.TextHeight('P');
  ThumbGrid.DefaultColWidth := ThumbGrid.Width - 4;
  if FReportOrientation = poPortrait then
   begin
     ThumbDrawWidth := Round((ThumbGrid.DefaultColWidth - 20));
     ThumbDrawHeight := Round((ThumbDrawWidth / QRPrinter.PaperWidth) * QRPrinter.PaperLength - ThumbFontHeight);
   end
  else
   begin
     ThumbDrawWidth := Round((ThumbGrid.DefaultColWidth - 20));
     ThumbDrawHeight := Round((ThumbDrawWidth / QRPrinter.PaperLength) * QRPrinter.PaperWidth - ThumbFontHeight);
   end;

  ThumbGrid.DefaultRowHeight := ThumbDrawHeight;
  ThumbLeftMargin := Round((ThumbGrid.DefaultColWidth - ThumbDrawWidth) / 2);
  ThumbTopMargin := Round((ThumbGrid.DefaultRowHeight - ThumbDrawHeight) / 2);
end;

end.
